# coding: utf-8

"""
    Sencity API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from sencity_client.configuration import Configuration


class ModuleSettingChanged(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'module_guid': 'str',
        'hub_guid': 'str',
        'key': 'str',
        'value': 'str'
    }

    attribute_map = {
        'module_guid': 'module_guid',
        'hub_guid': 'hub_guid',
        'key': 'key',
        'value': 'value'
    }

    def __init__(self, module_guid=None, hub_guid=None, key=None, value=None, local_vars_configuration=None):  # noqa: E501
        """ModuleSettingChanged - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._module_guid = None
        self._hub_guid = None
        self._key = None
        self._value = None
        self.discriminator = None

        if module_guid is not None:
            self.module_guid = module_guid
        if hub_guid is not None:
            self.hub_guid = hub_guid
        if key is not None:
            self.key = key
        if value is not None:
            self.value = value

    @property
    def module_guid(self):
        """Gets the module_guid of this ModuleSettingChanged.  # noqa: E501


        :return: The module_guid of this ModuleSettingChanged.  # noqa: E501
        :rtype: str
        """
        return self._module_guid

    @module_guid.setter
    def module_guid(self, module_guid):
        """Sets the module_guid of this ModuleSettingChanged.


        :param module_guid: The module_guid of this ModuleSettingChanged.  # noqa: E501
        :type: str
        """

        self._module_guid = module_guid

    @property
    def hub_guid(self):
        """Gets the hub_guid of this ModuleSettingChanged.  # noqa: E501


        :return: The hub_guid of this ModuleSettingChanged.  # noqa: E501
        :rtype: str
        """
        return self._hub_guid

    @hub_guid.setter
    def hub_guid(self, hub_guid):
        """Sets the hub_guid of this ModuleSettingChanged.


        :param hub_guid: The hub_guid of this ModuleSettingChanged.  # noqa: E501
        :type: str
        """

        self._hub_guid = hub_guid

    @property
    def key(self):
        """Gets the key of this ModuleSettingChanged.  # noqa: E501


        :return: The key of this ModuleSettingChanged.  # noqa: E501
        :rtype: str
        """
        return self._key

    @key.setter
    def key(self, key):
        """Sets the key of this ModuleSettingChanged.


        :param key: The key of this ModuleSettingChanged.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                key is not None and len(key) < 1):
            raise ValueError("Invalid value for `key`, length must be greater than or equal to `1`")  # noqa: E501

        self._key = key

    @property
    def value(self):
        """Gets the value of this ModuleSettingChanged.  # noqa: E501


        :return: The value of this ModuleSettingChanged.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this ModuleSettingChanged.


        :param value: The value of this ModuleSettingChanged.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                value is not None and len(value) < 1):
            raise ValueError("Invalid value for `value`, length must be greater than or equal to `1`")  # noqa: E501

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ModuleSettingChanged):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ModuleSettingChanged):
            return True

        return self.to_dict() != other.to_dict()
